LeetCode第169题:多数元素
程序员文章站
2024-03-22 14:21:52
...
题目详述
给定一个大小为 n 的数组,找到其中的多数元素。多数元素是指在数组中出现次数大于 ⌊ n/2 ⌋ 的元素。
你可以假设数组是非空的,并且给定的数组总是存在多数元素。
示例 1:
输入: [3,2,3]
输出: 3
示例 2:
输入: [2,2,1,1,1,2,2]
输出: 2
解法一
因为超过半数,所以排序后多数元素一定位于中间位置。
class Solution {
public int majorityElement(int[] nums) {
Arrays.sort(nums);
return nums[nums.length / 2];
}
}
解法二
使用HashMap存储,key为nums中的值,value为出现的次数
class Solution {
public int majorityElement(int[] nums) {
Map<Integer,Integer> map = new HashMap<>();
Map.Entry<Integer, Integer> majorityEntry = null;
for (int num : nums) {
if (!map.containsKey(num)) map.put(num, 1);
else map.put(num, map.get(num) + 1);
}
for (Map.Entry<Integer, Integer> entry : map.entrySet()) {
if (majorityEntry == null || entry.getValue() > majorityEntry.getValue())
majorityEntry = entry;
}
return majorityEntry.getKey();
}
}
解法三
分治。
class Solution {
private static int[] nums;
public int majorityElement(int[] nums) {
this.nums = nums;
return find(0,nums.length-1);
}
public static int find(int begin, int end){
// terminator
if (begin == end) return nums[begin];
// process the local logic
else {
int mid = (begin+end)/2;
int left = find(begin,mid);
int right = find(mid+1,end);
// reverse the current state
// 左右两部分的众数相同 则这个数是这部分的众数
if(left == right) return left;
else{
// 左右两部分的众数不相同 则这两个数都有可能是这部分的众数
// 那么遍历这个数组 看一下哪个数字的出现频率高
int countLeft = 0;
int countRight = 0;
for (int i = begin; i <= end; i++) {
if(nums[i] == left) countLeft++;
else if (nums[i] == right) countRight++;
}
return countLeft > countRight ? left : right;
}
}
}
}